<?php
/**
 * 1Gb API
 * @version 2.0.0
 */

require_once __DIR__ . '/vendor/autoload.php';

$app = new Slim\App();


/**
 * GET balanceGet
 * Summary: Аккаунт: баланс
 * Notes: Возвращает текущий баланс аккаунта
 * Output-Formats: [application/json]
 */
$app->GET('/balance', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing balanceGet as a GET method ?');
            return $response;
            });


/**
 * GET balanceLicGet
 * Summary: Аккаунт: баланс аккаунта лицензий
 * Notes: Возвращает текущий баланс аккаунта лицензий
 * Output-Formats: [application/json]
 */
$app->GET('/balance.lic', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing balanceLicGet as a GET method ?');
            return $response;
            });


/**
 * GET billingDebtGet
 * Summary: Информация по дебету аккаунта
 * Notes: Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
 * Output-Formats: [application/json]
 */
$app->GET('/billing/debt', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing billingDebtGet as a GET method ?');
            return $response;
            });


/**
 * GET billingInfoGet
 * Summary: Информация об аккаунте
 * Notes: Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
 * Output-Formats: [application/json]
 */
$app->GET('/billing/info', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing billingInfoGet as a GET method ?');
            return $response;
            });


/**
 * GET billingLimitsGet
 * Summary: Получить ограничения аккаунта
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/billing/limits', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing billingLimitsGet as a GET method ?');
            return $response;
            });


/**
 * GET dnsProlongListGet
 * Summary: Информация по продлению доменов
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/dns/prolong/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing dnsProlongListGet as a GET method ?');
            return $response;
            });


/**
 * GET emailAddGet
 * Summary: Создание почтового ящика
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/email/add', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $addEmail = $queryParams['addEmail'];    
            
            
            $response->write('How about implementing emailAddGet as a GET method ?');
            return $response;
            });


/**
 * GET emailAliasDeleteGet
 * Summary: Удаление псевдонимов почтовых ящиков
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/email/alias/delete', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    
            
            
            $response->write('How about implementing emailAliasDeleteGet as a GET method ?');
            return $response;
            });


/**
 * GET emailAliasListGet
 * Summary: Получить список псевдонимов почтовых ящиков
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/email/alias/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing emailAliasListGet as a GET method ?');
            return $response;
            });


/**
 * GET emailDeleteGet
 * Summary: Удаление почтового ящика
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/email/delete', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    
            
            
            $response->write('How about implementing emailDeleteGet as a GET method ?');
            return $response;
            });


/**
 * GET emailListGet
 * Summary: Получить список почтовых ящиков
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/email/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing emailListGet as a GET method ?');
            return $response;
            });


/**
 * GET updatesLastGet
 * Summary: Идентификатор последнего уведомления в аудите
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/updates/last', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing updatesLastGet as a GET method ?');
            return $response;
            });


/**
 * GET updatesListGet
 * Summary: Список записей аудита
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/updates/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    
            
            
            $response->write('How about implementing updatesListGet as a GET method ?');
            return $response;
            });


/**
 * GET websiteDeleteGet
 * Summary: Удаление сайта
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/website/delete', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    
            
            
            $response->write('How about implementing websiteDeleteGet as a GET method ?');
            return $response;
            });


/**
 * GET websiteListGet
 * Summary: Список сайтов аккаунта
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/website/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing websiteListGet as a GET method ?');
            return $response;
            });


/**
 * POST authLoginPost
 * Summary: Получить ключ доступа
 * Notes: Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр &#39;token&#39;). Для вычисления значения параметра &#39;response&#39; необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&amp;nbsp;+&amp;nbsp;salt&amp;nbsp;+&amp;nbsp;&#39;\\n&#39;))
 * Output-Formats: [application/json]
 */
$app->POST('/auth/login', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $login = $queryParams['login'];    $salt = $queryParams['salt'];    $response = $queryParams['response'];    
            
            
            $response->write('How about implementing authLoginPost as a POST method ?');
            return $response;
            });


/**
 * GET authStartGet
 * Summary: Получить соль
 * Notes: Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.
 * Output-Formats: [application/json]
 */
$app->GET('/auth/start', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $login = $queryParams['login'];    
            
            
            $response->write('How about implementing authStartGet as a GET method ?');
            return $response;
            });


/**
 * GET dnsAddGet
 * Summary: Создание записи домена
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/dns/add', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $addDnsZone = $queryParams['addDnsZone'];    $addDnsRecord = $queryParams['addDnsRecord'];    $iisSiteForDns = $queryParams['iisSiteForDns'];    $bindOnly = $queryParams['bindOnly'];    
            
            
            $response->write('How about implementing dnsAddGet as a GET method ?');
            return $response;
            });


/**
 * GET dnsBindGet
 * Summary: Привязка одного домена к другому
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/dns/bind', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    $bindTo = $queryParams['bindTo'];    
            
            
            $response->write('How about implementing dnsBindGet as a GET method ?');
            return $response;
            });


/**
 * GET dnsListGet
 * Summary: Получить список доменных имён
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/dns/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing dnsListGet as a GET method ?');
            return $response;
            });


/**
 * GET dnsProlongListGet
 * Summary: Информация по продлению доменов
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/dns/prolong/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing dnsProlongListGet as a GET method ?');
            return $response;
            });


/**
 * GET dnsRawGet
 * Summary: Редактирование \&quot;сырой\&quot; зоны
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/dns/raw', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    $sDel = $queryParams['sDel'];    $sAdd = $queryParams['sAdd'];    $dnsType = $queryParams['dnsType'];    $dnsName = $queryParams['dnsName'];    $dnsValue = $queryParams['dnsValue'];    
            
            
            $response->write('How about implementing dnsRawGet as a GET method ?');
            return $response;
            });


/**
 * GET dnsRawManagedmxGet
 * Summary: Редактировать DNS-зону
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/dns/raw/managedmx', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    $managedMx = $queryParams['managedMx'];    $updManagedMx = $queryParams['updManagedMx'];    
            
            
            $response->write('How about implementing dnsRawManagedmxGet as a GET method ?');
            return $response;
            });


/**
 * GET ftpListGet
 * Summary: Получить список зарегистрированных аккаунтов FTP
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/ftp/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing ftpListGet as a GET method ?');
            return $response;
            });


/**
 * GET iisListGet
 * Summary: Список сайтов IIS
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/iis/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing iisListGet as a GET method ?');
            return $response;
            });


/**
 * GET mssqlListGet
 * Summary: Получить список аккаунтов в MSSQL
 * Notes: 
 * Output-Formats: [application/json]
 */
$app->GET('/mssql/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing mssqlListGet as a GET method ?');
            return $response;
            });


/**
 * GET databaseListGet
 * Summary: Список аккаунтов в базах данных UNIX
 * Notes: Возвращает список зарегистрированных аккаунтов в базах данных MySQL и Postgres. Для вычисления имени домена необходимо объединить имя базы данных,   идентификатор сервера и суффикс (поле url_suffix). Например, если ID сервера равен 123 (значит это MySQL — см. описание поля &#39;server&#39; в ответе), а суффикс равен &#39;1gb.ru&#39;, то домен   для доступа будет равен &#39;mysql123.1gb.ru&#39;.
 * Output-Formats: [application/json]
 */
$app->GET('/database/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing databaseListGet as a GET method ?');
            return $response;
            });


/**
 * GET vdsCreateGet
 * Summary: Изменение параметров VDS
 * Notes: Изменение параметров уже существующего VDS
 * Output-Formats: [application/json]
 */
$app->GET('/vds/create', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $type = $queryParams['type'];    $crHvmem = $queryParams['crHvmem'];    $crHvdsk = $queryParams['crHvdsk'];    $crHvcpu = $queryParams['crHvcpu'];    $template = $queryParams['template'];    $forceMemo = $queryParams['forceMemo'];    $hv1gbPanelVersion = $queryParams['hv1gbPanelVersion'];    $panelInstall = $queryParams['panelInstall'];    $crSsd1 = $queryParams['crSsd1'];    $crHvAllSystem = $queryParams['crHvAllSystem'];    
            
            
            $response->write('How about implementing vdsCreateGet as a GET method ?');
            return $response;
            });


/**
 * GET vdsDeleteGet
 * Summary: Удаление VDS
 * Notes: Предоставляет функционал для удаления VDS
 * Output-Formats: [application/json]
 */
$app->GET('/vds/delete', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    $forceCritical = $queryParams['forceCritical'];    
            
            
            $response->write('How about implementing vdsDeleteGet as a GET method ?');
            return $response;
            });


/**
 * GET vdsIpAddGet
 * Summary: Добавление IP на VDS
 * Notes: Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
 * Output-Formats: [application/json]
 */
$app->GET('/vds/ip/add', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    
            
            
            $response->write('How about implementing vdsIpAddGet as a GET method ?');
            return $response;
            });


/**
 * GET vdsIpDeleteGet
 * Summary: Удаление IP с VDS
 * Notes: Этот вызов позволяет отвязать IP адрес от VDS
 * Output-Formats: [application/json]
 */
$app->GET('/vds/ip/delete', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    $delIp = $queryParams['delIp'];    
            
            
            $response->write('How about implementing vdsIpDeleteGet as a GET method ?');
            return $response;
            });


/**
 * GET vdsIpListGet
 * Summary: Список IP-адресов виртуальных серверов
 * Notes: Список IP-адресов виртуальных серверов
 * Output-Formats: [application/json]
 */
$app->GET('/vds/ip/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    
            
            
            $response->write('How about implementing vdsIpListGet as a GET method ?');
            return $response;
            });


/**
 * GET vdsListGet
 * Summary: Список виртуальных серверов
 * Notes: Позволяет получить список виртуальных серверов
 * Output-Formats: [application/json]
 */
$app->GET('/vds/list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    
            
            
            $response->write('How about implementing vdsListGet as a GET method ?');
            return $response;
            });


/**
 * GET vdsRebootGet
 * Summary: Перезагрузка VDS
 * Notes: Предоставляет функционал для перезагрузки VDS
 * Output-Formats: [application/json]
 */
$app->GET('/vds/reboot', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    
            
            
            $response->write('How about implementing vdsRebootGet as a GET method ?');
            return $response;
            });


/**
 * GET vdsTemplatesListGet
 * Summary: Список шаблонов виртуальных серверов
 * Notes: Позволяет получить список шаблонов виртуальных серверов
 * Output-Formats: [application/json]
 */
$app->GET('/vds/templates-list', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    
            
            
            $response->write('How about implementing vdsTemplatesListGet as a GET method ?');
            return $response;
            });


/**
 * GET vdsUpdateGet
 * Summary: Создание VDS
 * Notes: Создание новых VDS с произвольными характеристиками
 * Output-Formats: [application/json]
 */
$app->GET('/vds/update', function($request, $response, $args) {
            
            $queryParams = $request->getQueryParams();
            $token_ = $queryParams['token_'];    $key_ = $queryParams['key_'];    $crHvmem = $queryParams['crHvmem'];    $crHvdsk = $queryParams['crHvdsk'];    $crHvcpu = $queryParams['crHvcpu'];    
            
            
            $response->write('How about implementing vdsUpdateGet as a GET method ?');
            return $response;
            });



$app->run();
